/**
Bryn Mawr College, Department of Computer Science <br>
Two graphical primitive classes to demo inheritance
*/

Ellipse e = new Ellipse(150, 250, 120, 50);
Circle c = new Circle(350, 250, 30);

void setup() {
  size(500, 500);
  smooth();
  e.draw();
  c.draw();
}

void draw() {
}

// Ellipse base class
class Ellipse {
  float x;
  float y;
  float w;
  float h;

  // Ellipses are always red
  color fillColor = color(255, 0, 0);

  Ellipse(float x, float y, float w, float h) {
    this.x = x;
    this.y = y;
    this.w = w;
    this.h = h;
  }

  void draw() {
    ellipseMode(CENTER);
    fill(fillColor);
    ellipse(x, y, w, h);
  }
}

// Circle derived class
class Circle extends Ellipse {

  Circle(float x, float y, float r) {
    super(x, y, 2*r, 2*r);
    // Circles are always green
    fillColor = color(0, 255, 0);
  }
}


