/**
Bryn Mawr College, Department of Computer Science <br>
Two graphical primitive classes to demo inheritance <br>
Circles change color if clicked on
*/
Ellipse[] e = new Ellipse[20];

void setup() {
  size(500, 500);
  smooth();

  for (int i=0; i<e.length; i++) {
    float x = random(0, width);
    float y = random(0, height);
    float w = random(10, 100);
    float h = random(10, 100);

    // Ellipses are Circles are stored
    // in the same array
    if (random(1.0) < 0.5)
      e[i] = new Ellipse(x, y, w, h);
    else
      e[i] = new Circle(x, y, 0.5*w);
  }
}

void draw() {
  for (int i=0; i<e.length; i++)
    e[i].draw();
}

void mousePressed() {
  for (int i=0; i<e.length; i++)
    e[i].mousePressed();
}

// Ellipse base class
class Ellipse {
  float x;
  float y;
  float w;
  float h;

  // Ellipses are always red
  color fillColor = 
    color(255, 0, 0);

  Ellipse(float x, float y, float w, float h) {
    this.x = x;
    this.y = y;
    this.w = w;
    this.h = h;
  }

  void draw() {
    ellipseMode(CENTER);
    fill(fillColor);
    ellipse(x, y, w, h);
  }

  // Do nothing
  void mousePressed() {
  }
}

// Circle derived class
class Circle extends Ellipse {

  Circle(float x, float y, float r) {
    super(x, y, 2*r, 2*r);

    // Circles are always blue
    fillColor = color(0, 255, 0);
  }

  // Change color of circle when clicked
  void mousePressed() {
    if (dist(mouseX, mouseY, x, y) < 0.5*w)
      fillColor = color(0, 0, 255);
  }
}


