/**
Dianna Xu <br>
Bryn Mawr College, Department of Computer Science <br>
Another variation on emergentCircles.pde.
*/

Circle[] cs = new Circle[35];
ArrayList bubbles;

void setup() {
  size(800, 800);
  smooth();

  for (int i=0; i<cs.length; i++) {
    if (i%20 == 0) {
      cs[i] = new Circle(random(width), random(height), random(150, 200), i);
    }
    else {
      cs[i] = new Circle(random(width), random(height), random(50), i);
    }
  }
  bubbles = new ArrayList();
} // end setup()

void draw() {
  background(0);
  for (int i=0; i<cs.length; i++) {
    //cs[i].display();
    cs[i].update(cs);
  }
  for (int i = bubbles.size() - 1; i >= 0; i--) {
    Bubble b = (Bubble)bubbles.get(i);
    if (b.update()) {
      bubbles.remove(i);
    }
    else {
      b.display();
    }
  }
} // end draw()

void keyPressed() {
  save(minute()+"-"+second());
} // end keyPressed()

class Bubble extends Circle{
  int age;

  Bubble(PVector pos, color c) {
    super(pos.x, pos.y, 0, -1);
    v = new PVector(random(width)-pos.x, random(height)-pos.y);
    v.normalize();
    this.c = c;
    age = 0;
  } // end Bubble()

  void display() {
    if (age > 0) {
      stroke(c, 255-age);
      fill(red(c)/2, green(c)/2, blue(c)/2, 255-age*2);
      ellipse(center.x, center.y, sqrt(age*4), sqrt(age*4));
    }
  } // end display()

  boolean update() {
    center.add(v);
    age++;
    return age > 75;
  } // end update()
} // end class Bubble

class Circle {
  PVector center;
  float radius;
  PVector v;
  color c;
  int id;

  Circle (float x, float y, float radius, int id) {
    center = new PVector(x, y, 0);
    this.radius = radius;
    v = new PVector(random(-5, 5), random(-5, 5));
    c = color(random(255));
    this.id = id;
  } // end Circle()

  void display() {
    fill(c);
    stroke(c);
    ellipse(center.x, center.y, radius*2, radius*2);
  } // end display()

  void update(Circle[] cs) {
    center.add(v);

    for (int i=id+1; i<cs.length; i++) {
      float dist = PVector.dist(center, cs[i].getCenter());
      float tangentDist = radius + cs[i].getRadius();

      if (dist <= tangentDist) {
        float overlap = tangentDist-dist;
        color newC = (c + cs[i].getColor())/2;
        //PVector newCenter = PVector.add(center, cs[i].getCenter());
        //newCenter.div(2);
        PVector dir = PVector.sub(cs[i].getCenter(), center);
        dir.normalize();
        dir.mult(radius);
        PVector newCenter = PVector.add(center, dir);
        bubbles.add(new Bubble(newCenter, newC));
        
//        PVector acc = PVector.sub(center, cs[i].center);
//        acc.normalize();
//        v.add(acc);
//        cs[i].v.sub(acc);
      }
    } 

    if (center.x < 0 || center.x > width) {
      v.x = -v.x;
    }
    if (center.y < 0 || center.y > height) {
      v.y = -v.y;
    }
  } // end update()
  
  PVector getCenter() {return center;}
  float getRadius() {return radius;}
  color getColor() {return c;}
} // end class Circle


