/**
Bryn Mawr College, Department of Computer Science <br>
Adapt ball dropping program so that if two balls get close, the bigger ball absorbs the smaller one. <br>
Things to add: <br>
sort the balls by size <br>
modify velociy <br>
modify color <br>
*/


Ball[] balls = new Ball[20];

void setup() {
  size(500, 500);
  fill(255, 0, 0);
  smooth();
  ellipseMode(CENTER);

  // Create all new Ball objects
  for (int i = 0; i < balls.length; i++) {
    balls[i] = new Ball();
  }
}

void draw() {
  background(255);

  for (int i = 0; i < balls.length; i++) {
    balls[i].update();
    balls[i].draw();
  }
  for (int i = 0; i < balls.length; i++) {
    for (int j = i+1; j < balls.length; j++) {
      if (balls[i].collidedWith(balls[j])) {
        float balliWeighting = balls[i].getArea() / (balls[i].getArea() + balls[j].getArea());
        float balljWeighting = balls[j].getArea() / (balls[i].getArea() + balls[j].getArea());
        color c1 = balls[i].c;
        color c2 = balls[j].c;
        balls[i].c = color(red(c1)*balliWeighting + red(c2)*balljWeighting,
                           green(c1)*balliWeighting + green(c2)*balljWeighting,
                           blue(c1)*balliWeighting + blue(c2)*balljWeighting);
        balls[i].d = 2.0*sqrt((balls[i].getArea() + balls[j].getArea())/PI);
        balls[i].sx = balls[i].sx*balliWeighting + balls[j].sx*balljWeighting;
        balls[i].sy = balls[i].sy*balliWeighting + balls[j].sy*balljWeighting;
        balls[i].vx = balls[i].vx*balliWeighting + balls[j].vx*balljWeighting;
        balls[i].vy = balls[i].vy*balliWeighting + balls[j].vy*balljWeighting;
        balls[j].d = 0.0;
      }
    }
  }
}

class Ball {
  // Fields
  float ay = 0.2;     // y acceleration (gravity)
  float sx;    // x position
  float sy;    // y position
  float vx;    // x velocity
  float vy;    // y velocity
  float d;
  color c;

    // Constructor
  Ball() {
    sx = random(0.0, width);
    sy = random(0.0, height);
    vx = random(-3.0, 3.0);
    vy = random(-5.0, 5.0);
    c = color(random(0,255),random(0,255),random(0,255));
    d = random(5,100);
  }

  // Methods
  void update() {
    // Move ball
    sx += vx;
    sy += vy;
    vy += ay;

    // Bounce off walls and floor
    if (sx <= d/2.0 || sx >= (width-d/2.0)) vx = -vx;
    if (sy >= (height-d/2.0) && vy > 0.0) vy = -0.9*vy;
  }
  
  boolean collidedWith(Ball b) {
    return sqrt((sx - b.sx)*(sx - b.sx) + (sy - b.sy)*(sy - b.sy)) <= (d + b.d)/2.0;
  }
  
  float getArea() {
     return PI*(d/2.0)*(d/2.0); 
  }
  
  void draw() {
    fill(c);
    ellipse( sx, sy, d, d);
  }
}


