/**
Bryn Mawr College, Department of Computer Science <br>
Many balls dropping
*/

int numBalls = 20;
Ball[] bs = new Ball[numBalls];

void setup() {
  size(400, 400);
  smooth();

  for (int i=0; i<bs.length; i++) {
    int r = int(random(255));
    int g = int(random(255));
    int b = int(random(255));
    bs[i] = new Ball(int(random(20, width/2)), int(random(20, height/2)), color(r, g, b));
  }
}

void draw() {
  background(255);
  for (int i=0; i<bs.length; i++) {
    bs[i].update();
    bs[i].display();
  }
}

class Ball {
  int w;
  int h;
  float x;
  float y;
  float spdX;
  float spdY;
  float gravity = .03;
  color c;

  // Constructor
  Ball() {
    w = h = 20;
    x = random(0, width/2);
    y = random(10, 20);
    spdX = random(0.5, 1.3);
    spdY = 0;
    c = color(255, 255, 255);
  }
  
  Ball(int x, int y, color c) {
    w = h = 20;
    spdX = random(0.5, 1.5);
    spdY = 0;
    this.x = x;
    this.y = y;
    this.c = c;
  }

  void update() {
    x += spdX; 
    spdY += gravity; 
    y += spdY;

    // reaching right or left edge, reverse x
    if (x + w/2 > width || x - w/2 < 0) {
      spdX = -spdX;
    }

    // reaching bottom or top edge, reverse y and apply damping
    if ( y + h/2 > height || y - h/2 < 0) {
      spdY = -spdY;
    }
  }

  void display() {
    fill(c);
    ellipse(x, y, w, h);
  }
}


