/**
Bryn Mawr College, Department of Computer Science <br>
Ball drop with array, variation.
*/

Ball[] balls = new Ball[100];

void setup() {
  size(600, 600);
  smooth();

  for (int i=0; i<balls.length; i++) {
    int x = int(random(20, width/2));
    int y = int(random(20, height/2));
    color c = color(random(255), random(255), random(255));
    balls[i] = new Ball();
  }
}

void draw() {
  background(255);
  for (int i=0; i<balls.length; i++) {
    balls[i].update();
    balls[i].display();
  }
}

class Ball {
  int w;
  int h;
  float x;
  float y;
  float spdX;
  float spdY;
  float gravity = .03;
  color c;

  // Constructor
  Ball() {
    w = h = 20;
    x = random(width/2-5, width/2+5);
    y = random(height/2-5, height/2+5);
    spdX = random(-5, 5);
    spdY = random(-5, 5);
    c = color(random(255), random(255), random(255));
  }
  
  Ball(int x, int y, color c) {
    w = h = 20;
    spdX = random(-1.3, 1.3);
    spdY = 0;
    this.x = x;
    this.y = y;
    this.c = c;
  }

  void update() {
    x += spdX; 
    spdY += gravity; 
    y += spdY;

    // reaching right or left edge, reverse x
    if (x + w/2 > width ) {
      x = width - w/2;
      spdX = -spdX;
    }
    else if (x - w/2 < 0) {
      x = w/2;
      spdX = -spdX;
    }

    // reaching bottom or top edge, reverse y and apply damping
    if ( y + h/2 > height) { 
      y = height - h/2;
      spdY = -spdY;
    }
    else if (y - h/2 < 0) {
      y = h/2;
      spdY = -spdY;
    }
  }

  void display() {
    fill(c);
    ellipse(x, y, w, h);
  }
}


