/**
Bryn Mawr College, Department of Computer Science <br>
Polygon objects combined with simple physics makes a particle system
*/

int count = 100;
Polygon[] p = new Polygon[count];
float[] spdXs = new float[count];
float[] spdYs = new float[count];

void setup() {
  size(400, 400);
  background(255);
  noStroke();
  fill(127);
  
  for ( int i=0; i<count; i++){
    p[i] = new Polygon(random(2, 20), int(random(3, 9)) );
    spdXs[i] = random(-3, 3);
    spdYs[i] = random(-3, 3);
    p[i].setSpeed(spdXs[i], spdYs[i]);
  }
}


void draw() {
  background(255);
  for ( int i=0; i<count; i++){
    p[i].move();
    p[i].display();
  }
}


class Polygon {
  float x, y;
  float radius;
  int sides;
  float spdX, spdY;
  float gravity, damping, friction;
  color c;

  Polygon() {
    init();
  }

  Polygon(float radius, int sides) {
    this.radius = radius;
    this.sides = sides;
    init();
  }

  void init() {
    x = random(width);
    y = random(-50, 0);
    gravity = .03;
    friction = .85;
    damping = .75;
    c = color(random(50), random(100), random(100), random(50, 150));
  }

  void display() {    
    float theta = 0.0; 
    fill(c);   
    beginShape();    
    for (int i=0; i<sides; i++) {
      float xcoord = cos(theta);
      float ycoord = sin(theta);
      vertex(xcoord*radius+x, ycoord*radius+y);
      theta += TWO_PI/sides;
    }
    endShape(CLOSE);
  }

  void move() {
    x += spdX;
    spdY += gravity;
    y += spdY;

    if (x>width-radius) {
      x = width-radius;
      spdX = -spdX;
    } 
    else if (x<radius) {
      x = radius;
      spdX = -spdX;
    }


    if (y>height-radius) {
      y = height-radius;
      spdY = -spdY;
      spdY *= damping;
      spdX *= friction;
    } 
    else if (y<radius) {
      y = radius;
      spdY = -spdY;
    }
  }

  void setSpeed(float spdX, float spdY) {
    this.spdX = spdX;
    this.spdY = spdY;
  }
}


