/**
Bryn Mawr College, Department of Computer Science <br>
Click mouse to drop a box. Boxes are kept in an ArrayList and deleted after dropping out of sketch bottom.
*/

// Box Dropper
ArrayList boxes = new ArrayList();

void setup() { size(500, 500); }

void draw() {
  background(0);

  for (int i = boxes.size()-1; i>=0; i--) {
    //boxes.get(i).draw();      // Fails. Why?
    Box b = (Box)boxes.get(i);  // Type cast Object->Box
    if (b.update()) {
      boxes.remove(i);
      println(boxes.size() + " boxes remaining");
    }
    else {
      b.draw();
    }
  }
}

void mousePressed() {
  Box b = new Box(mouseX, mouseY);  
  boxes.add( b );
  println( boxes.size() + " boxes in ArrayList" );
}

// A simple Box class
class Box {
  float x, y, v;
  
  Box(float tx, float ty) {
    x = tx;  // x position
    y = ty;  // y position
    v = 0.0; // y velocity
  }
  
  void draw() {
    fill(200);
    rect(x, y, 20, 20);
  }
  
  boolean update(){
    y += v;         
    v += 0.02;
    return (y>height);
  }
}


