/**
Bryn Mawr College, Department of Computer Science <br>
More basic version of fireworks with a top-level ArrayList
*/

class Fire {
  float x;
  float y;
  float vx;
  float vy;
  color col;
  float lifetime = 100;

  Fire(float x, float y, float vx, float vy, color col) {
    this.x = x;
    this.y = y;
    this.vx = vx;
    this.vy = vy;
    this.col = col;
  }

  void draw() {
    if (lifetime-50>0) {
      noStroke();
      fill(col, lifetime-50);
      ellipse(x, y, 4, 4);
      lifetime -= 0.5;
    }
  } 

  void update() {
    vy += G;
    x += vx;
    y += vy;
  }
}

ArrayList<Fire> fireworks = new ArrayList();
final float G = 0.04;

void setup() {
  size(400, 400);
}

void draw() {
  noStroke();
  background(0);
  for (int i = 0; i < fireworks.size(); i++) {
    fireworks.get(i).update();
    fireworks.get(i).draw();
  }
}

void mousePressed() {
  fireworks.clear();
  color c = color(random(50, 255), random(50, 255), random(50, 255));
  int numFires = (int)random(4, 1000);
  for (int i=0; i<numFires; i++) {
    float r = random(0, TWO_PI);
    float R = random(0, 2);
    fireworks.add(new Fire(mouseX, mouseY, R*sin(r), R*cos(r), c));
  }
}


