/**
Bryn Mawr College, Department of Computer Science <br>
Simulation of a ball dropping, final version with friction
*/

int w, h;                // width and height of ball
float x, y;              // initial position    
float spdX, spdY;        // speed in X and Y directions  
float gravity, damping;  // coeffecients for acceleration and damping
float friction;

void setup(){
 size(400, 400);
 background(255);
 x = width/2;
 y = 20;
 spdX = 1.3;
 spdY = 0.0;
 w = h = 20;
 gravity = .03;
 damping = .65;
 friction = 0.99;
}


void draw(){
  background(255);
  ellipse(x, y, w, h);
  
  x = x + spdX; 
  spdY = spdY + gravity; 
  y = y + spdY;
  
  // reaching right edge, reverse x
  if (x + w/2 > width){
    spdX = -spdX;
  }
  
  // reaching left edge, reverse x
  if (x - w/2 < 0){
    spdX = -spdX;
  }
  
  // reaching bottom edge, reverse y and apply damping
  if (y + h/2 > height){
    y = height - h/2;
    spdY = -spdY;
    spdY = spdY * damping;
    spdX = spdX * friction;
  }
  
  // reaching top edge, reverse y
  if (y - h/2 < 0){
    spdY = -spdY;
  }
}

