/**
Bryn Mawr College, Department of Computer Science <br>
The walker, controlled by arrow keys <br>
Must click in screen first before keys will function.
*/

boolean walking = false;    // true if walking
boolean walkPose = false;   // current walk pose
float speed = 2.0;          // walk speed
float cX = 100.0;           // current walker location
float cY = 100.0;

void setup() {
  size(500, 500);
  smooth();
  frameRate(20);
}

void draw() {
  background(255);
  
  // Test current keyPressed
  if (keyPressed == true) {
    switch( keyCode ) {
      case UP:
        walking = true;
        cY -= speed;
        break;
      case DOWN:
        walking = true;
        cY += speed;
        break;
      case LEFT:
        walking = true;
        cX -= speed;
        break;
      case RIGHT:
        walking = true;
        cX += speed;
        break;
      default:
        walking = false;
    }
  } 
  else {
    walking = false;
  }
  
  // Draw the walker 
  // Space legs based on current walk step
  fill(200);
  stroke(0);
  line(cX, cY, cX, cY+20);           // body
  ellipse(cX, cY, 10, 10);           // head
  if (walkPose == true) {
    line(cX-10, cY+10, cX+10, cY+10);// arms at pose 1
    line(cX, cY+20, cX-10, cY+30);   // legs at pose 1
    line(cX, cY+20, cX+10, cY+30);
  } 
  else {
    line(cX-10, cY+5, cX+10, cY+15); // arms at pose 2
    line(cX, cY+20, cX-5, cY+30);    // legs at pose 2
    line(cX, cY+20, cX+5, cY+30);  
  }
  
  // If walking, change walk pose.
  if (walking == true) {
    walkPose = !walkPose;
  }
}

