/**
Bryn Mawr College, Department of Computer Science <br>
Draws a happy face at mouse click, or by pressing 'h' or 'H'.
Must click in screen first before keys will function.
*/

void setup() {
  size(500, 500);
  background(0);
  smooth();
}

void draw() { }

void mousePressed() {
  // If mouse pressed, draw large happy face
  float diam = random(30, 60);
  happyFace( mouseX, mouseY, diam );
}

void keyPressed() {
  // If h-key pressed, draw small happy face
  if (key == 'h' || key == 'H') {
    float diam = random(10, 30);
    happyFace( mouseX, mouseY, diam );
  }
}

// Draw happy face
void happyFace( float x, float y, float diam )
{
  // Face
  fill(255, 255, 0);
  stroke(0);
  strokeWeight(2);
  ellipseMode(CENTER);  
  ellipse(x, y, diam, diam );
  
  // Smile
  float startAng = 0.1*PI;
  float endAng = 0.9*PI;
  float smileDiam = 0.6*diam;
  arc(x, y, smileDiam, smileDiam, startAng, endAng);
  
  // Eyes
  float offset = 0.2*diam;
  float eyeDiam = 0.1*diam;
  fill(0);
  ellipse(x-offset, y-offset, eyeDiam, eyeDiam);
  ellipse(x+offset, y-offset, eyeDiam, eyeDiam);
}

