/**
Bryn Mawr College, Department of Computer Science <br>
mosedrag on an array of circles
*/

Circle[] circs;      // 1. Array to hold all circles

void setup() {
  size(500, 500);
  smooth();
  
  // 2. Create an array to hold Circles
  circs = new Circle[10];
  
  // 3. Create Circles and store in array
  for (int i=0; i<circs.length; i++) {
    String name = "Circle" + i;
    float x = random(width);
    float y = random(height);
    circs[i] = new Circle(x, y, 50, name);
  }
}

void draw() {
  background(255);
  
  // 5. Delegate all draw behavior to Ellipse objects
  for (int i=0; i<circs.length; i++) {
    circs[i].draw();
  }
}

void mousePressed() {
  // 6. Delegate mouse pressed
  for (int i=0; i<circs.length; i++) {
    circs[i].mousePressed();
  }  
}

void mouseReleased() {
  // 7. Delegate mouse released
  for (int i=0; i<circs.length; i++) {
    circs[i].mouseReleased();
  }  
}

void mouseDragged() {
  // 8. Delegate mouse dragged
  for (int i=0; i<circs.length; i++) {
    circs[i].mouseDragged();
  }  
}
// Circle class
class Circle {

  float x;
  float y;
  float radius;
  String name;
  color fillColor = color(255);  // Fill color of circle
  boolean dragging = false;

  Circle(float tx, float ty, float tr, String tn)
  {
    x = tx;
    y = ty;
    radius = tr;
    name = tn;
  }

  void draw() {
    // 9. Draw circle
    fill(fillColor);
    ellipse( x, y, 2*radius, 2*radius );
  }

  void mousePressed() {
    // 10. Change dragging state if mouse pressed on circle
    if ( dist( mouseX, mouseY, x, y ) < radius ) { 
      dragging = true;
      fillColor = color(255, 0, 0);
    }
  }

  void mouseReleased() {
    // 11. Stop dragging when mouse released
    dragging = false;
    fillColor = color(255);
  }

  void mouseDragged() {
    // 12. If dragging, move circle under mouse
    if ( dragging == true ) { 
      x = mouseX; 
      y = mouseY;
    }
  }
}


