/**
Bryn Mawr College, Department of Computer Science <br>
Implement a tooltip on mouse hover, hover means > 0.5 seconds
*/

float x = 250;        // Ellipse parameters
float y = 250;
float radius = 50;
float hoverStart;     // Keep track of hover start time

void setup() {
  size(500, 500);
  smooth();
}

void draw() {
  // 1. Clear the background
  background(255);
  
  // 2. Draw the shape using the current fill color
  fill(255, 0, 0);
  ellipse( x, y, 2*radius, 2*radius);

  // 3. Add tooltip if the mouse is over ellipse.
  if ( dist( mouseX, mouseY, x, y ) < radius ) {
    
    // 4. Only show if hover time is > 0.5 second
    if ( millis() - hoverStart > 500 ) {
      fill(0);
      text("I'm over the ellipse", mouseX, mouseY);
    }
  }
}

void mouseMoved() {
  // 5. Reset hover start time on each move over ellipse
  if ( dist( mouseX, mouseY, x, y ) < radius ) {
    hoverStart = millis();
  }  
}


