/**
Bryn Mawr College, Department of Computer Science <br>
mouseover for an array of circles
*/

Circle[] circs;      // Array to hold all circles

void setup() {
  size(500, 500);
  smooth();
  
  // Create an array to hold Circles
  circs = new Circle[10];
  
  // Create Circles
  for (int i=0; i<circs.length; i++) {
    String name = "Circle" + i;
    float x = random(width);
    float y = random(height);
    circs[i] = new Circle(x, y, 50, name);
  }
}

void draw() {
  background(255);
  
  // Delegate all draw behavior to Circle objects
  // Draw top down, and stop if circle responds.
  for (int i=0; i<circs.length; i++) {
    circs[i].draw();
  }
}
// Circle class
class Circle {

  float x;
  float y;
  float radius;
  String name;
  
  Circle(float tx, float ty, float tr, String tn)
  {
    x = tx;
    y = ty;
    radius = tr;
    name = tn;
  }
  
  void draw() {
    // Set fill color based on whether or not
    // the mouse is over the circle.
    if ( dist( mouseX, mouseY,x, y ) < radius ) {
      fill( 255, 0, 0 );
    } else {
      fill( 0, 255, 0 );
    }
    
    // Draw the shape using the current fill color
    ellipse( x, y, 2*radius, 2*radius);
  }
}

