/**
Bryn Mawr College, Department of Computer Science <br>
Creates a moving truck. Based on trucks.pde <br>
Every time a truck emerges from the left it is of different size <br>
Also, click on truck to see a puff behind the truck
*/

float tx, ty, ts;
color tc;
float deltaX = 2;
boolean puff;
float puffSize;

void setup() {
  size(500, 500);
  smooth();

  // first truck
  ts = random(60, 150);
  tx = -ts;
  ty = height/2;
  tc = color(random(50, 200));
  puff = false;
  puffSize = ts/4;
} // setup()

void draw() {
  background(255);
  stroke(0);
  line(0, height/2, width, height/2);

  fill(tc);
  noStroke();
  drawTruck(tx, ty, ts, ts/2);

  tx += deltaX;
  if (tx > width) {
    ts = random(60, 150);
    tx = -ts;
    tc = color(random(50, 200));
    puff = false;
    puffSize = ts/4;
  }
} // draw()

void mousePressed() {
  if (inTruck(mouseX, mouseY, tx, ty, ts)) {
    puff = true;
    puffSize = ts/4;
  }
} // mousePressed()

boolean inTruck(float x, float y, float rx, float ry, float s) {
  return (x >= rx && x <= rx+s) && (y <= ry && y >= ry-s/2);
} // inTruck

void drawTruck(float x, float y, float w, float h) {
  // draws a truck anchored at x, y of width w, height h
  //rect(x, y-h, w, h);

  // draw truck's body
  beginShape();
  vertex(x, y-0.1*h);
  vertex(x, y-h);
  vertex(x+w*0.6, y-h);
  vertex(x+w*3/4, y-0.5*h);
  vertex(x+w*0.9, y-0.5*h);
  vertex(x+w*0.9, y-0.1*h);
  endShape(CLOSE);

  // front end
  if (random(1) < 1) {
    beginShape();
    curveVertex(x+w*0.9, y-0.5*h);
    curveVertex(x+w*0.9, y-0.5*h);
    curveVertex(x+w*0.95, y-0.1*h);
    curveVertex(x+w*0.9, y-0.1*h);
    curveVertex(x+w*0.9, y-0.1*h);
    endShape(CLOSE);
  }
  else {
    beginShape();
    curveVertex(x+w*0.9, y-0.5*h);
    curveVertex(x+w*0.9, y-0.5*h);
    curveVertex(x+w*0.95, y-0.5*h);
    curveVertex(x+w*0.9, y-0.1*h);
    curveVertex(x+w*0.9, y-0.1*h);
    endShape(CLOSE);
  }
  // draw driver's window
  fill(255);
  triangle(x+w*0.6, y-0.9*h, x+0.6*w, y-0.5*h, x+0.7*w, y-0.5*h);

  // draw banner, optionally
  if (random(1) < 1) {
    fill(200);
    rect(x+0.1*w, y-0.9*h, w*0.4, h*0.4);
  }

  // draw the wheels
  float wheelSz = h*0.2;
  float wheelX = x + 0.25*w;
  float wheelY = y - 0.1*h;
  fill(0);
  // rear wheel
  ellipse(wheelX, wheelY, wheelSz, wheelSz);
  // front wheel
  ellipse(wheelX+0.5*w, wheelY, wheelSz, wheelSz);

  // puff
  if (puff) {
    noStroke();
    fill(tc);
    ellipse(tx-ts/8, ty-ts/8, puffSize, puffSize/2);
    puffSize--;
    if (puffSize < 1)
      puff = false;
  }
} // drawTruck()


