/**
Bryn Mawr College, Department of Computer Science <br>
Draws a truck of random color and width at mouse point, using a function.
*/

void setup() {

  size(500, 500);
  background(240, 206, 206);
  smooth();
} // setup()

void draw() {
} // draw()

void mousePressed() {
  fill(random(50, 200));
  noStroke();
  float w = random(60, 150);
  float h = w*0.5;
  drawTruck(mouseX, mouseY, w, h);
} // mousePressed()

void drawTruck(float x, float y, float w, float h) {
  // draws a truck anchored at x, y of width w, height h
  //rect(x, y-h, w, h);

  // draw truck's body
  beginShape();
  vertex(x, y-0.1*h);
  vertex(x, y-h);
  vertex(x+w*0.6, y-h);
  vertex(x+w*3/4, y-0.5*h);
  vertex(x+w*0.9, y-0.5*h);
  vertex(x+w*0.9, y-0.1*h);
  endShape(CLOSE);

  // front end
  if (random(1) < 0.5) {
    beginShape();
    curveVertex(x+w*0.9, y-0.5*h);
    curveVertex(x+w*0.9, y-0.5*h);
    curveVertex(x+w*0.95, y-0.1*h);
    curveVertex(x+w*0.9, y-0.1*h);
    curveVertex(x+w*0.9, y-0.1*h);
    endShape(CLOSE);
  }
  else {
    beginShape();
    curveVertex(x+w*0.9, y-0.5*h);
    curveVertex(x+w*0.9, y-0.5*h);
    curveVertex(x+w*0.95, y-0.5*h);
    curveVertex(x+w*0.9, y-0.1*h);
    curveVertex(x+w*0.9, y-0.1*h);
    endShape(CLOSE);
  }
  // draw driver's window
  fill(255);
  triangle(x+w*0.6, y-0.9*h, x+0.6*w, y-0.5*h, x+0.7*w, y-0.5*h);

  // draw banner, optionally
  if (random(1) < 0.5) {
    fill(200);
    rect(x+0.1*w, y-0.9*h, w*0.4, h*0.4);
  }

  // draw the wheels
  float wheelSz = h*0.2;
  float wheelX = x + 0.25*w;
  float wheelY = y - 0.1*h;
  fill(0);
  // rear wheel
  ellipse(wheelX, wheelY, wheelSz, wheelSz);
  // front wheel
  ellipse(wheelX+0.5*w, wheelY, wheelSz, wheelSz);
} // drawTruck()


