/**
Bryn Mawr College, Department of Computer Science <br>
Inspired by the Maui Bus Logo <br>
Two 5-petal flowers are drawn overlapping so tha tthey produce the illusion of a third flower...
*/


float x, y, r;

void setup() {
  size(500, 500);
  smooth();
  background(0);
  noLoop();
  x = width/2;
  y = height/2;
  r = 200;
}

void draw() {
  drawFlower(x, y, r, 0, color(12, 213, 137));
  drawFlower(x, y, r, PI/5, color(255, 255, 0, 200));
}

void drawFlower(float cx, float cy, float radius, float angle, color c){
  int n = 5;
  float theta = 2*PI/n;
  //float angle = 0;
  float x1, y1, x2, y2;

  for (int i=0; i < n; i++) {
    x2 = cx + radius*sin(angle);
    y2 = cy + radius*cos(angle);
    x1 = cx + radius/2*sin(angle+radians(30));
    y1 = cy + radius/2*cos(angle+radians(30));
    noStroke();
    fill(c);

    beginShape();
    curveVertex(cx, cy);
    curveVertex(cx, cy);
    curveVertex(x1, y1);
    curveVertex(x2, y2);

    x1 = cx + radius/2*sin(angle-radians(30));
    y1 = cy + radius/2*cos(angle-radians(30));
    curveVertex(x1, y1);
    curveVertex(cx, cy);
    curveVertex(cx, cy);
    endShape(CLOSE);
    angle+=theta;
  } // for
} // drawFlower



