/**
Deepak Kumar <br>
Bryn Mawr College, Department of Computer Science <br>
Mandala variation, with color
*/

void setup() {
  size(500, 500);
  smooth();
  noLoop();
} //setup()

void draw() {
  background(139, 116, 245);
  drawMandala(width/2, height/2, 400);
} // draw()

void drawMandala(float cx, float cy, float r) {
  // inner star
  strokeWeight(2);
  stroke(0);
  noFill();
  float cr = r/2;
  int nSides = 6;
  int delta = 360/nSides;

  // draw the outer rim
  stroke(1);
  fill(255, 0, 0);
  ellipse(cx, cy, cr*2, cr*2);

  // draw inner rim
  stroke(1);
  fill(255, 255, 0, 200);
  ellipse(cx, cy, cr*2-40, cr*2-40);

  // draw "spokes" in the rim
  float theta = 0;
  strokeWeight(2);
  for (int i=0; i < nSides; i++) {
    float x1 = cx + cr*cos(radians(theta));
    float y1 = cy + cr*sin(radians(theta));
    float x2 = cx + (cr-20)*cos(radians(theta));
    float y2 = cy + (cr-20)*sin(radians(theta));
    line(x1, y1, x2, y2);
    theta += delta;
  }
  cr -= 20;

  // draw the biggest stars
  cr /= 2;
    fill(72, 232, 37, 100);
  drawStar(cx, cy, cr*2, nSides, 0);
  fill(16, 77, 2, 100);
  drawStar(cx, cy, cr*2, nSides, delta/2);

  // Draw the middle two stars
    fill(245, 116, 120, 100);
  drawStar(cx, cy, cr, nSides, 0);
  fill(255, 0, 0, 100);
  drawStar(cx, cy, cr, nSides, delta/2); 

  // draw the innermost two stars
  cr /= 2;
  strokeWeight(2);
  fill(16, 77, 2, 100);
  drawStar(cx, cy, cr, nSides, delta/2);
  fill(255, 255, 0, 100);
  drawStar(cx, cy, cr, nSides, 0);

} // drawMandala()

void drawStar(float cx, float cy, float radius, int n, float deg) {
  // draws a star centered at cx, cy of radius r and with n points
  float theta = radians(deg);
  float delta = 2*PI/n; 
  float iDelta = delta/2;
  float outR = radius;
  float inR = radius/2;

  beginShape();
  for (int i = 0; i < n; i++) {
    // plot outer point
    vertex(cx+outR*cos(theta), cy+outR*sin(theta));
    // plot inner point
    vertex(cx+inR*cos(theta+iDelta), cy+inR*sin(theta+iDelta));
    theta = theta + delta;
  }
  endShape(CLOSE);
} // drawStar


