/**
Bryn Mawr College, Department of Computer Science <br>
Basic flower is a variation on spoke. Define a petal around each spoke, essentially.
*/

void setup() {
  size(500, 500);
  smooth();
}

void draw() {
  background(0);
  stroke(255);
  flower(width/2, height/2, 140, 5);
}


void flower(int cx, int cy, int radius, int n) {
 float  incr, theta, delta, x, y;
 float tip = radius/5;
 theta = 0.0;
 incr = 2 * PI / n;
 delta = incr/3;
 

 noStroke(); 
 for (int i=0; i < n; i++) {
   // Draw the petal
   fill(255, 0, 255);          // petal color
   
   // each petal is a closed curve
   beginShape();
   curveVertex(cx, cy);  
   curveVertex(cx+tip/2*cos(theta), cy+tip/2*sin(theta));
   x = cx + radius*cos(theta-delta);
   y = cy + radius*sin(theta-delta);
   curveVertex(x, y);
   
   x = cx + (radius+tip)*cos(theta);
   y = cy + (radius+tip)*sin(theta);
   curveVertex(x, y);
   
   x = cx + radius*cos(theta+delta);
   y = cy + radius*sin(theta+delta);
   curveVertex(x, y);
   curveVertex(cx+tip/2*cos(theta), cy+tip/2*sin(theta));
   curveVertex(cx, cy);
   endShape();
   stroke(255, 0, 255);
   //line(cx, cy, cx+1*tip*cos(theta), cy+1*tip*sin(theta));
   //line(cx, cy, cx+radius*cos(theta), cy+radius*sin(theta));
   theta += incr;
  }
   // draw the center disc
 stroke(255, 255, 0);
 fill(255, 255, 0);          // center disc color
 //ellipse(cx, cy, tip, tip);  // center disk
 spokes(cx, cy, (int)tip, 50);

}

void spokes(int cx, int cy, int radius, int n) { 
 float  incr, theta;
 theta = 0.0;
 incr = 2 * PI / n;
 float x, y;
 for (int i=0; i < n; i++) {
   x = cx+radius*cos(theta);
   y = cy+radius*sin(theta);
   line(cx, cy, x, y);
//   if ((int)random(10)==0) {
//     strokeWeight(3);
//     point(x, y);
//     strokeWeight(1);
//   }
   theta += incr;
  }
}

