/**
Bryn Mawr College, Department of Computer Science <br>
Variation of poly5.pde
*/

void setup() {
  size(600, 600);
  smooth();
  noFill();
  strokeWeight(3);


  float sz = 250;
  float theta = 0;
  for (int i=1; i<sz; i++) {
    stroke(150+i, 50+i, 50-i, i);
    //poly(width/2, height/2, sz-i, 4, random(PI/4));
    polyStar(width/2, height/2, sz-i, (sz-i)/3, 10, random(PI/4)+theta);
    theta+=PI/i;
  }
}

void draw() {
}

// draws a regular polygon with the following parameters:
// x, y  -- x and y location of center
// rad   -- radius of circle 
// sides -- number of sides
// theta -- starting angle of rotation
void poly(float x, float y, float rad, int sides, float theta) {
  float xcoord, ycoord;
  beginShape();
  for (int i=0; i<sides; i++) {
    xcoord = cos(theta);
    ycoord = sin(theta);
    vertex(xcoord*rad+x, ycoord*rad+y); 
    theta += TWO_PI/sides;
  }
  endShape(CLOSE);
}

void polyStar(float x, float y, float or, float ir, int pts, float theta) {
  float xcoord, ycoord; 
  int vs = pts*2;

  beginShape();
  xcoord = cos(theta-TWO_PI/vs);
  ycoord = sin(theta-TWO_PI/vs);
  curveVertex(xcoord*or+x, ycoord*or+y);    
  for (int i=0; i<vs/2+1; i++) {
    xcoord = cos(theta);
    ycoord = sin(theta);
    curveVertex(xcoord*or+x, ycoord*or+y);
    theta += TWO_PI/vs;
    xcoord = cos(theta);
    ycoord = sin(theta);
    curveVertex(xcoord*ir+x, ycoord*ir+y);
    theta += TWO_PI/vs;
  }
  endShape(CLOSE);
}


