/**
Bryn Mawr College, Department of Computer Science <br>
Variation on polygon drawing <br>
Mouse X position in sketch determines number of sides <br>
Mouse y position in sketch determines size of polygon
*/


void setup() {

  size(500, 500);

  smooth();
} // setup()

void draw() {
  background(255);
  strokeWeight(5);
  drawPolygon(width/2, height/2, mouseY/2, int(20*mouseX/width));
} // draw()

void drawPolygon(float cx, float cy, float radius, int vertices) {
  // draws a polygon centered at cx, cy of radius r and with vertices
  float theta = 0.0;
  float delta = TWO_PI/vertices;

  point(cx, cy);

  float x1, y1, x2, y2;

  x1 = cx + radius*cos(theta);
  y1 = cy + radius*sin(theta);

  for (int i = 0; i < vertices; i++) {

    theta = theta + delta;

    x2 = cx + radius*cos(theta);
    y2 = cy + radius*sin(theta);

    line(x1, y1, x2, y2);

    x1 = x2;
    y1 = y2;
  }
} // drawPolygon


