/**
Bryn Mawr College, Department of Computer Science <br>
Variation from simple spokes to a polygonal star drawn with curved vertices
*/

void setup() {
  size(500, 500);
  smooth();
}

void draw() {
  background(0);
  stroke(255);
  strokeWeight(3);
  fill(#01C1C5);
  spokes(250, 250, 100, 40);
}

void spokes(int cx, int cy, int radius, int n) {
  float r;
  float  incr, theta;
  theta = 0.0;
  incr = 2 * PI / n;
  float x, y, x1, y1;
  float ir = radius;
  
  beginShape();
  theta = 2*PI - incr;
  x = cx+radius*cos(theta);
  y = cy+radius*sin(theta);
  curveVertex(x, y);
  theta = 0;
  //x1 = cx+radius*cos(0);
  //y1 = cy+radius*sin(0);

  for (int i=0; i < n; i++) {
    if (i%2 == 0)
      r = radius+ir;
    else
      r = radius;
    //line(cx, cy, cx+radius*cos(theta), cy+radius*sin(theta));
    x = cx+r*cos(theta);
    y = cy+r*sin(theta);
    theta += incr;

    curveVertex(x, y);
  }

  curveVertex(cx+(ir+radius)*cos(theta), cy+(ir+radius)*sin(theta));
  theta += incr;
  x1 = cx+(ir+radius)*cos(theta);
  y1 = cy+(ir+radius)*sin(theta);
  curveVertex(x1, y1);
  endShape();
}


