/**
Bryn Mawr College, Department of Computer Science <br>
Variation on star drawing <br>
Mouse X position in sketch determines number of sides <br>
Mouse y position in sketch determines size
*/

void setup() {
  size(500, 500);
  smooth();
} // setup()

void draw() {
  background(255);
  strokeWeight(5);
  drawStar(width/2, height/2, mouseY/2, 20*mouseX/width);
} // draw()

void drawStar(float cx, float cy, float radius, int n) {
  // draws a star centered at cx, cy of radius r and with n points
  float theta = 0.0;
  float delta = 2*PI/n; 
  float iDelta = delta/2;
  float outR = radius;
  float inR = radius/2;

  point(cx, cy);

  beginShape();
  for (int i = 0; i < n; i++) {
    // plot outer point
    vertex(cx+outR*cos(theta), cy+outR*sin(theta));
    // plot inner point
    vertex(cx+inR*cos(theta+iDelta), cy+inR*sin(theta+iDelta));
    theta = theta + delta;
  }
  endShape(CLOSE);
} // drawStar


