/**
Bryn Mawr College, Department of Computer Science <br>
Mr. Potatohead, with objects.
*/

/* @pjs preload = "potatoheadleftarm.png, potatoheadrightarm.png"; */

class EyeWithGaze {
  color eyeColor;
  float direction;

  EyeWithGaze(color eyeColorIn) {
    eyeColor = eyeColorIn;
    direction = 0.0;
  }

  void draw(float x, float y) {
    fill(255);
    ellipse(x, y, 30, 50);

    fill(eyeColor);
    ellipse(x+10.0*sin(direction), y, 15, 15);
    stroke(0);
    fill(204, 128, 0);

    arc(x, y-10, 30, 50, PI, 2*PI);
    direction += .05;
  }
}

class BlinkyHat {
  color hatColor;
  int count;

  BlinkyHat(color hatColorIn) {
    hatColor = hatColorIn;
    count = 0;
  }
  
  void draw(float x, float y) {
    // draw hat
    fill(hatColor);
    arc(x, y, 110, 100, PI, 2*PI);
    rect(x-70, y, 140, 10);
    color blinkyColor;
    if (count % 3 == 0) {
      blinkyColor = color(255,0,0);
    } else if (count % 3 == 1) {
      blinkyColor = color(0,255,0);
    } else  {
      blinkyColor = color(0,0,255);
    }
    fill(blinkyColor);
    ellipse(x,y,10,10);

    count++;
  }
}


class Mouth {
  // how many teeth for top and bottom
  int numTeeth;

  Mouth(int numTeethIn) {
    numTeeth = numTeethIn;
  }

  void draw(float x, float y) {
    fill(255);
    ellipse(x, y, 100, 33);
    stroke(0);
    line(x-50, y, x+50, y);
    // draw vertical lines to divide the teeth
    for (int i = 1; i < numTeeth; i++) {
      line(x-50+i*10, y-10, x-50+i*10, y+10);
    }
    // draw the mustache
    fill(0);
    beginShape();
    vertex(x-70, y);
    bezierVertex(x-10, y-100, x+28, y-10, x-25, y-20);
    endShape();

    beginShape();
    vertex(x+70, y);
    bezierVertex(x+10, y-100, x-28, y-10, x+25, y-20);
    endShape();
  }
}

class PotatoHead {
  EyeWithGaze leftEye;
  EyeWithGaze rightEye;
  Mouth mouth;
  BlinkyHat hat;

  PotatoHead(EyeWithGaze leftEyeIn, EyeWithGaze rightEyeIn, Mouth mouthIn, BlinkyHat hatIn) {
    leftEye = leftEyeIn;
    rightEye = rightEyeIn;
    mouth = mouthIn;
    hat = hatIn;
  }

  void draw() {
    // Draw Potathead Outline
    fill(204, 128, 0);
    beginShape();
    vertex(322, 59);
    bezierVertex(337, 152, 378, 132, 375, 269);
    bezierVertex(346, 342, 290, 343, 262, 338);
    bezierVertex(261, 339, 197, 327, 184, 281);
    bezierVertex(153, 231, 214, 156, 216, 69);
    bezierVertex(234, 25, 309, 32, 322, 59);
    endShape();

    // Draw Shoes    
    fill(0, 0, 200);
    arc(330, 360, 80, 70, PI, 2*PI);
    arc(330-90, 360, 80, 70, PI, 2*PI);
    fill(255, 0, 0);
    rect(330-40, 360, 80, 5);
    rect(330-40-90, 360, 80, 5);

    // draw the ears
    fill(255, 153, 153);
    bezier(358-150, 116+15, 320-150, 65+15, 295-150, 172+15, 340-150, 165+15);
    bezier(322+21, 124, 365+23, 88, 375+23, 169, 342+25, 181);
    // draw the arms
    PImage img = loadImage("potatoheadrightarm.png");
    image(img, 55, 185, 120, 80);
    PImage img2 = loadImage("potatoheadleftarm.png");
    image(img2, 376, 185, 120, 80);

    fill(245, 156, 61);
    // Draw the nose
    ellipse(275, 205, 25, 45);

    // Call classes draw method inside to draw themselves to the screen
    leftEye.draw(290, 160);
    rightEye.draw(260, 160);
    mouth.draw(278, 270);
    hat.draw(270,70);
  }
}

PotatoHead head;

void setup() {
  size(500, 500);
  EyeWithGaze leftEye = new EyeWithGaze(color(0, 0, 0));
  EyeWithGaze rightEye = new EyeWithGaze(color(0, 0, 0));

  BlinkyHat hat = new BlinkyHat(color(0,0,0));
  Mouth mouth = new Mouth(10);

  head = new PotatoHead(leftEye, rightEye, mouth, hat);
}

void draw() {
  background(255);
  head.draw();
}


