/**
Bryn Mawr College, Department of Computer Science <br>
Variation of ballDropObject
*/

Ball b1, b2, b3;

void setup() {
  size(400, 400);
  smooth();

  b1 = new Ball(width/2, 20, color(255, 0, 0));
  b2 = new Ball(width/4, 50, color(255, 255, 0));
  b3 = new Ball();
}

void draw() {
  background(255);
  b1.update();
  b1.display();
  b2.update();
  b2.display();
  b3.update();
  b3.display();
}

class Ball {
  int w;
  int h;
  float x;
  float y;
  float spdX;
  float spdY;
  float gravity = .03;
  color c;

  // Constructor
  Ball() {
    w = h = 20;
    x = random(0, width/2);
    y = random(10, 20);
    spdX = random(0.5, 1.3);
    spdY = 0;
    c = color(255, 255, 255);
  }
  
  Ball(int x, int y, color c) {
    w = h = 20;
    spdX = random(0.5, 1.3);
    spdY = 0;
    this.x = x;
    this.y = y;
    this.c = c;
  }

  void update() {
    x += spdX; 
    spdY += gravity; 
    y += spdY;

    // reaching right or left edge, reverse x
    if (x + w/2 > width || x - w/2 < 0) {
      spdX = -spdX;
    }

    // reaching bottom or top edge, reverse y and apply damping
    if ( y + h/2 > height || y - h/2 < 0) {
      spdY = -spdY;
    }
  }

  void display() {
    fill(c);
    ellipse(x, y, w, h);
  }
}


