/**
Bryn Mawr College, Department of Computer Science <br>
Variation of polyStar
*/

void setup() {
  size(500, 500);
  smooth();
  strokeWeight(5);
  fill(255, 100, 0);
  stroke(255,157, 0, 175);
  //Polygon p = new Polygon(width/2, height/2, 90, 12);
  int sz = width/3;
  Star s = new Star(width/2, height/2, sz, sz/2, (int) random(5, 15));
  
  //p.display();
  s.display();
}

void draw() {
}

class Polygon{
  float x, y;
  float radius;
  int sides;
     
  Polygon(float x, float y, float radius, int sides){
    this.x = x;
    this.y = y;
    this.radius = radius;
    this.sides = sides;
  }
  
  void display(){
    float xcoord, ycoord;    
    float theta = 0.0;    
    beginShape();    
    for (int i=0; i<sides; i++){
      xcoord = cos(theta);
      ycoord = sin(theta);
      vertex(xcoord*radius+x, ycoord*radius+y);
      theta += TWO_PI/sides;
    }
    endShape(CLOSE);
  }
}
class Star {
  float x, y;
  float or;
  float ir;
  int vs;

  Star(float x, float y, float or, float ir, int points) {
    this.x = x;
    this.y = y;
    this.or = or;
    this.ir = ir;
    this.vs = points*2;
  }

  void display() {    
    float theta = 0.0;
    float xcoord = 0.0, ycoord = 0.0; 
    float incr = TWO_PI/vs;   
    beginShape();
    xcoord = cos(TWO_PI-incr);
    ycoord = sin(TWO_PI-incr);
    curveVertex(xcoord*ir+x, ycoord*ir+y);
    for (int i=0; i<vs; i++) {
      xcoord = cos(theta);
      ycoord = sin(theta);
      if(i%2 == 0) {
        curveVertex(xcoord*or+x, ycoord*or+y);
      }
      else {
        curveVertex(xcoord*ir+x, ycoord*ir+y);
      }
      theta += incr;
    }
    curveVertex(cos(theta)*or+x, sin(theta)*or+y);
    theta+= incr;
    curveVertex(cos(theta)*or+x, sin(theta)*or+y);
    endShape();
  }
}


