/**
Bryn Mawr College, Department of Computer Science <br>
Polygon drawn as object
*/

Polygon p;

void setup() {
  size(400, 400);
  background(255);
  noStroke();
  fill(255, 150, 0);
  
  p = new Polygon(random(25, 50), int(random(3, 9)));
  p.display();
}

class Polygon {
  float x, y;
  float radius;
  int sides;
    
  Polygon(){
    init();
  }
  
  Polygon(float radius, int sides){
    this.radius = radius;
    this.sides = sides;
    init();
  }
  
  void init(){
    x = width/2;
    y = height/2;
  }
  
  void display(){
    
    float theta = 0.0;
    
    pushMatrix();
    translate(x, y);
    scale(radius);
    
    beginShape();    
    for (int i=0; i<sides; i+=1){
      float x = cos(theta);
      float y = sin(theta);
      //strokeWeight(1);
      vertex(x, y);
      theta += TWO_PI/sides;
    }
    endShape(CLOSE);
    
    popMatrix();
  }
}

