/**
Bryn Mawr College, Department of Computer Science <br>
Star and polygon classes
*/

void setup() {
  size(500, 500);
  smooth();
  strokeWeight(5);
  Polygon p = new Polygon(width/2, height/2, 90, 12);
  Star s = new Star(width/2, height/2, 90, 20, int(random(5, 15)));
  
  p.display();
  s.display();
}

void draw() {
}

class Polygon{
  float x, y;
  float radius;
  int sides;
     
  Polygon(float x, float y, float radius, int sides){
    this.x = x;
    this.y = y;
    this.radius = radius;
    this.sides = sides;
  }
  
  void display(){    
    float theta = 0.0;    
    beginShape();    
    for (int i=0; i<sides; i++){
      float xcoord = cos(theta);
      float ycoord = sin(theta);
      vertex(xcoord*radius+x, ycoord*radius+y);
      theta += TWO_PI/sides;
    }
    endShape(CLOSE);
  }
}
class Star {
  float x, y;
  float or;
  float ir;
  int vs;

  Star(float x, float y, float or, float ir, int points) {
    this.x = x;
    this.y = y;
    this.or = or;
    this.ir = ir;
    this.vs = points*2;
  }

  void display() {    
    float theta = 0.0;
    float xcoord, ycoord;    
    beginShape();    
    for (int i=0; i<vs/2; i++) {
      xcoord = cos(theta);
      ycoord = sin(theta);
      vertex(xcoord*or+x, ycoord*or+y);
      theta += TWO_PI/vs;
      xcoord = cos(theta);
      ycoord = sin(theta);
      vertex(xcoord*ir+x, ycoord*ir+y);
      theta += TWO_PI/vs;
    }
    endShape(CLOSE);
  }
}


