
void setup() {
  size(500,500);
  drawRoom(0,0,width,height, 1);
}


void draw() {}

void drawRoom(int startX, int startY, int stopX, int stopY, float brightness) {
  int w = stopX - startX;
  int h = stopY - startY;
  
  //base case
  if (w + h < 3) {
    return;
  }
  
  // screen coordinates
  int screenStartX = startX + int(0.3*w);
  int screenStopX = stopX - int (0.3*w);
  int screenStartY = startY + int(0.2*w);
  int screenStopY = stopY - int(0.4*w);
  
  // wall coordinates
  int wallStartX = startX + int(0.2*w);
  int wallStopX = stopX - int (0.2*w);
  int wallStartY = startY + int(0.15*w);
  int wallStopY = stopY - int(0.35*w);

  rectMode(CORNER);
  
  // draw the background
  noStroke();
  fill(150*brightness);
  rect(startX, startY, w, h);
  
  // draw the room
  stroke(2);
  rect(wallStartX, wallStartY, wallStopX - wallStartX, wallStopY - wallStartY);
  line(startX,stopY,wallStartX,wallStopY);
  line(stopX, stopY, wallStopX, wallStopY);
  line(startX,startY,wallStartX,wallStartY);
  line(stopX, startY, wallStopX, wallStartY);
  
  // draw the screen
  stroke(2);
  fill(255 * brightness);
  rect(screenStartX, screenStartY, screenStopX-screenStartX, screenStopY-screenStartY);
  
  
  // recurse
  drawRoom(screenStartX+5, screenStartY+5, screenStopX-5, screenStopY-5, brightness*.8);
}
  

