/**
Bryn Mawr College, Department of Computer Science <br>
An in-class exercise for topdown design <br>
Step 7: <br>
Keep track of score <br>
Add score variable <br>
Change Balloon.pop() to return the score resulting from the pop attempt <br>
Add score to running sum and display score in header <br>
Prevent mousePressed from doing anything if game is over
*/ 

// Declare game variables
Balloon[] balloons;
int elapsedTime = 0;
int gameTime = 30;
int score = 0;

void setup() {

  // Setup sketch
  size(500, 500);
  smooth();
  
  // Create and initialize all balloons
  balloons = new Balloon[10];
  for (int i=0; i<balloons.length; i++) {
    balloons[i] = new Balloon();
  }
}

void draw() {
  // Update elapsedTime
  elapsedTime = int(millis()/1000);

  // Check for game over
  if (elapsedTime > gameTime) return;

  // Inflate balloons
  inflateBalloons();

  // Clear background
  background(255);

  // Draw all balloons
  drawBalloons();

  // Draw header
  drawHeader();
}

void mousePressed() {
  // Check for game over
  if (elapsedTime > gameTime) return;

  // Pop balloons with this mouse location
  // Increment score
  for (int i=0; i<balloons.length; i++) {
    score = score + balloons[i].pop(mouseX, mouseY);
  }
}

// Draw header
void drawHeader(){
  fill(0);
  textSize(24);
  textAlign(CENTER, CENTER);
  String msg = "Popped " + score + " balloons in " + elapsedTime + " seconds";
  text(msg, 0.0, 0.0, width, 100.0);
}

// Inflate Balloons
void inflateBalloons() {
  for (int i=0; i<balloons.length; i++) {
    balloons[i].inflate();
  }
}

// Draw Balloons
void drawBalloons() {
  for (int i=0; i<balloons.length; i++) {
    balloons[i].draw();
  }
}

class Balloon {
  // Track of Balloon location, diameter and color
  float x;
  float y;
  float diam;
  color clr;
  
  // Initialize all Balloon fields
  Balloon() {
    reset();
  }

  void reset() {
    x = random(0, width);
    y = random(0, height);
    diam = 0.0;
    clr = color(random(200,255),random(200,255),random(200,255));
  }

  void draw() {
    ellipseMode(CENTER);
    fill(clr);
    stroke(0);
    ellipse(x, y, diam, diam);
  }

  int pop(float px, float py) {
    // If player has popped the balloon, reset to a new balloon.
    if ( dist(x, y, px, py) < 0.5*diam ) {
      reset();
      return 1;
    } else {
      return 0;
    }
  }

  // Inflate the Balloon
  void inflate() {
    diam = diam + 0.5;
  }

}

