/**
Bryn Mawr College, Department of Computer Science <br>
Starfield using 3D tranformations. This is slow in Javascript.
*/

Star[] stars = new Star[400];

void setup() {
  size(600, 600, OPENGL);
  float cameraZ = height/2/tan(PI/6);
  perspective(PI/3, (float) width/(float) height, cameraZ/100, cameraZ*10000.0);
  smooth();
  stroke(255);
  strokeWeight(3);

  // Init all stars
  for (int i=0; i<stars.length; i++) 
    stars[i] = new Star();
}

void draw() {
  background(0);

  // Draw all stars wrt center of screen
  translate(width/2, height/2);

  // Update and draw all stars
  for (int i=0; i<stars.length; i++) {
    stars[i].update();
    stars[i].draw();
  }
}

class Star {
  // Star coordinates in 3D
  float x;
  float y;
  float z;
  
  Star() {
    x = random(-5000, 5000);
    y = random(-5000, 5000);
    z = random(-10000, 0);
  }
  
  void update() {
    z+=50;        // Move star closer to viewport
    if (z >= 0.0) // Reset star if it passes viewport
      reset();
  }
  
  void reset() {
    // Reset star to a position far away
    x = random(-5000, 5000);
    y = random(-5000, 5000);
    z = -10000.0;
  }

  void draw() {
    pushMatrix();
    translate(x, y, z);
    ellipse(0,0,5,5);
    popMatrix();
  }
}

