/**
Bryn Mawr College, Department of Computer Science <br>
Boxoffice data visualization: Social Network 2010
*/

PFont f;

String[] s;
float[] data;
float[] item;

float dataMax;
float xmin, xmax, ymin, ymax;

void setup() {
  size(1000, 400);
  smooth();
  noLoop();
  background(0);

  f = createFont("Broadway", 16, true);
  textFont(f);

  // acquire and parse data
  s = loadStrings("SocialNetwork10-1-11-7.txt");
  println("Read " + s.length + " lines.");

  // Create array to store earnings
  data = new float[s.length];

  // Separate earnings and theater count and convert to float
  for (int i=0; i<s.length; i++) {
    // Convert array of strings to array of floats
    item = float(split(s[i], ','));
    data[i] = item[0];
  }

  // data is now filled, lets do some stuff
  dataMax = max(data);

  // set some graph dimensions
  xmin = 50; 
  ymin = 50;
  xmax = width-50; 
  ymax = height-50;
}

float x, y;     // the origin of the graph
float dx, dy;   // the data points to plot

void draw() {
  background(175);
  noStroke();
  fill(251, 255, 229);
  rect(xmin, ymin, xmax-xmin, ymax-ymin);
  stroke(143, 80, 255);
  strokeWeight(10);

  for (int i=0; i<data.length; i++) {
    dx = map(i, 0, data.length-1, xmin, xmax);
    dy = map(data[i], 0, dataMax, ymax, ymin);
    point(dx, dy);
  }
}


