/**
Bryn Mawr College, Department of Computer Science <br>
Boxoffice data visualization: Social Network 2010 <br>
Line plot
*/

PFont f;

String[] s;
float[] data;
float[] item;

float dataMax;
float xmin, xmax, ymin, ymax;

void setup() {
  size(1000, 400);
  smooth();
  noLoop();
  background(0);
  f = createFont("Broadway", 16, true);
  textFont(f);

  // Acquire and parse data
  s = loadStrings("SocialNetwork10-1-11-7.txt");
  println("Read " + s.length + " lines.");

  // Create array to store earnings
  data = new float[s.length];

  // Separate earnings and theater count and convert to float
  for (int i=0; i<s.length; i++) {
    item = float(split(s[i], ','));
    data[i] = item[0];
  }

  // Data is now filled, lets do some stuff
  dataMax = max(data);

  // Set some graph dimensions
  xmin = 50; 
  ymin = 50;
  xmax = width-50; 
  ymax = height-50;
}

float x, y;     // the origin of the graph
float dx, dy;   // the data points to plot
float px, py;   // the previous plotted point
void draw() {

  background(175);
  noStroke();
  fill(251, 255, 229);
  rect(xmin, ymin, xmax-xmin, ymax-ymin);
  stroke(143, 80, 255);

  // Init previous point
  px = xmin; 
  py = ymax;

  for (int i=0; i<data.length; i++) {
    // Next point
    dx = map(i, 0, data.length-1, xmin, xmax);
    dy = map(data[i], 0,  dataMax, ymax, ymin);
    
    // Draw point
    strokeWeight(10);
    point(dx, dy);
    
    // Draw line between previous and current points
    strokeWeight(0.5);
    line(px, py, dx, dy);
    
    // Reassign current point to previous point
    px = dx;
    py = dy;
  }
}


