/**
Bryn Mawr College, Department of Computer Science <br>
Pie chart, data from a file
*/ 

// Arrays to hold data
String[] s;
float [] data;
String[] labels;

float x, y, w;
float angle, theta;
float total = 0.0;

float kx, ky, kw, ks;
float currentHue=0;
float deltaHue;

void setup() {
  size(500, 500);
  smooth();
  noLoop();
  background(255);

  // Center and size of chart
  x = width/2 - 100;
  y = height/2;
  w = 200;
  
  // Init Legend
  kx = x + 0.75*w;
  ky = y - 0.5*w;
  kw = 20;
  ks = 10;

  // Load and normalize data
  s = loadStrings("survey.txt");
  data = float(split(s[0],","));
  labels = split(s[1],",");
  
  for (int i=0; i<data.length; i++) 
    total += data[i];
  for (int i=0; i<data.length; i++) 
    data[i] = 100.0*(data[i] / total);

  colorMode(HSB);
  deltaHue = 255.0/data.length;  
}

void draw() {
  angle = 0;

  for (int i = 0; i < data.length; i++) {
    // Draw the ith Pie
    fill( color(currentHue,240,240) );
    theta = angle + data[i]*2*PI/100.0;
    arc(x, y, w, w, angle, theta);
    angle = theta;
    currentHue += deltaHue;
        
    ky = ky + 2*kw;
    rect(kx, ky, kw, kw);
    fill(0);
    text(labels[i], kx+kw+ks, ky+kw);
  }

}

