/**
Bryn Mawr College, Department of Computer Science <br>
States drawn as polygons, animated.
*/ 

String[] rawText;
ArrayList states;
int counter = 10;

void setup() {
  size(700, 500);
  smooth();

  // read the state data as raw text
  rawText = loadStrings("statedata.txt");
  states = new ArrayList();

  // parse data
  for (int i=0; i< rawText.length; i=i+2) {
    State s = new State(rawText[i], rawText[i+1]);
    states.add(s);
  }
  frameRate(5);
  background(100);
}

void draw() {
  scale(0.5);
  stroke(0);
  fill(255, 255, 0);
  
  // Get the next State object and display
  State st = (State)states.get(counter);
  st.display();
  
  // Increment counter
  counter = (counter+1)%states.size();
}
class State {  
  String name, ST, capital;
  float capX, capY;
  float[] points;
  color c;
  
  // Constructor takes two lines from the file
  // First is state and capitol, second is outline
  State(String stText, String p) {
    String[] stData = split(stText, ",");
    
    name = stData[0];
    ST = stData[1];
    capital = stData[2];
    capX = float(stData[3]);
    capY = float(stData[4]);
    
    points = float(split(p, ","));
    c = color(random(255), random(255), random(255));
  } // State
  
  // Draw state outline
  void display() {   
    fill(c);
    beginShape();
    for (int i=0; i<points.length; i=i+2) {
      vertex(points[i], points[i+1]);
    }
    endShape(CLOSE);
  } // display
} // end of class State

